﻿Public Class Form1
    Private onImage As Image = Image.FromFile("..\..\checkon.png")
    Private offImage As Image = Image.FromFile("..\..\checkoff.png")
    Private editor As CustomEditor
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ' Create Data
        Dim name As New List(Of Persons)()
        name.Add(New Persons() With {.Name = "Robert Ludlum", .ID = 1, .Present = True})
        name.Add(New Persons() With {.Name = "John Smith", .ID = 2, .Present = False})
        name.Add(New Persons() With {.Name = "Frederick Forsyth", .ID = 3, .Present = True})
        name.Add(New Persons() With {.Name = "Dan Brown", .ID = 4, .Present = False})
        name.Add(New Persons() With {.Name = "Tom Clancy", .ID = 5, .Present = True})

        ' TrueDBGrid Settings
        C1TrueDBGrid1.DataSource = name
        C1TrueDBGrid1.SpringMode = True

        ' Setting the column ID (cell type drop-down)
        Dim items As C1.Win.C1TrueDBGrid.ValueItems = Me.C1TrueDBGrid1.Columns("ID").ValueItems
        items.Translate = True
        items.Values.Add(New C1.Win.C1TrueDBGrid.ValueItem(1, "A"))
        items.Values.Add(New C1.Win.C1TrueDBGrid.ValueItem(2, "B"))
        items.Values.Add(New C1.Win.C1TrueDBGrid.ValueItem(3, "C"))
        items.Values.Add(New C1.Win.C1TrueDBGrid.ValueItem(4, "D"))
        items.Values.Add(New C1.Win.C1TrueDBGrid.ValueItem(5, "E"))

        editor = New CustomEditor()
        editor.Items.Add(New CustomItem(1, "A"))
        editor.Items.Add(New CustomItem(2, "B"))
        editor.Items.Add(New CustomItem(3, "C"))
        editor.Items.Add(New CustomItem(4, "D"))
        editor.Items.Add(New CustomItem(5, "E"))

        'Set custom editor for column "ID"
        C1TrueDBGrid1.Columns("ID").Editor = editor

        'Set Column appearance
        C1TrueDBGrid1.Splits(0).DisplayColumns("ID").Style.HorizontalAlignment = C1.Win.C1TrueDBGrid.AlignHorzEnum.Near
        C1TrueDBGrid1.Splits(0).DisplayColumns("ID").HeadingStyle.HorizontalAlignment = C1.Win.C1TrueDBGrid.AlignHorzEnum.Near
        C1TrueDBGrid1.Splits(0).DisplayColumns("ID").Width = 80

        ' Column settings Test (cell type check box)
        C1TrueDBGrid1.Splits(0).DisplayColumns("Present").Locked = True
        C1TrueDBGrid1.Splits(0).DisplayColumns("Present").OwnerDraw = True
        C1TrueDBGrid1.Splits(0).DisplayColumns("Present").Width = 80

        C1TrueDBGrid1.RowHeight = editor.PreferredHeight - 1
    End Sub

    Private Sub C1SizerLight1_ResizingFont(sender As Object, e As C1.Win.C1Sizer.C1SizerLightEventArgs) Handles C1SizerLight1.ResizingFont
        ' Adjust RowHeight and Font
        If e.Control.Name = Me.C1TrueDBGrid1.Name Then
            C1TrueDBGrid1.Splits(0).HeadingStyle.Font = C1TrueDBGrid1.Font
            C1TrueDBGrid1.Splits(0).Style.Font = C1TrueDBGrid1.Font
            editor.Font = C1TrueDBGrid1.Font
            C1TrueDBGrid1.RowHeight = editor.PreferredHeight - 1
        End If
    End Sub

    Private Sub C1TrueDBGrid1_Click(sender As Object, e As System.EventArgs) Handles C1TrueDBGrid1.Click
        ' Toggle checkbox's checked state
        Dim row, col As Integer
        Dim pos As Point = C1TrueDBGrid1.PointToClient(Control.MousePosition)
        C1TrueDBGrid1.CellContaining(pos.X, pos.Y, row, col)
        If col > -1 AndAlso C1TrueDBGrid1.Splits(0).DisplayColumns(col).Name = "Present" Then
            C1TrueDBGrid1(row, col) = Not C1TrueDBGrid1(row, col)
        End If
    End Sub

    Private Sub C1TrueDBGrid1_OwnerDrawCell(sender As Object, e As C1.Win.C1TrueDBGrid.OwnerDrawCellEventArgs) Handles C1TrueDBGrid1.OwnerDrawCell
        ' Draw checkbox
        If e.Column.Name = "Present" Then
            e.Handled = True
            Dim rect As Rectangle = e.CellRect
            e.Graphics.FillRectangle(Brushes.White, rect)
            Dim pos As New Point(rect.Left + (rect.Width - rect.Height) / 2, rect.Top)
            If e.Text = "True" Then
                e.Graphics.DrawImage(onImage, New Rectangle(pos, New Size(rect.Height, rect.Height - 2)))
            ElseIf e.Text = "False" Then
                e.Graphics.DrawImage(offImage, New Rectangle(pos, New Size(rect.Height, rect.Height - 2)))
            End If
        End If
    End Sub
End Class

''' <summary>
''' ComboBox Editor Type
''' </summary>
Public Class CustomEditor
    Inherits ComboBox
    Implements C1.Win.C1FlexGrid.IC1EmbeddedEditor

    Public Function C1EditorFormat(ByVal value As Object, ByVal mask As String) As String Implements C1.Win.C1FlexGrid.IC1EmbeddedEditor.C1EditorFormat
        Return String.Concat(value)
    End Function

    Public Function C1EditorGetStyle() As System.Drawing.Design.UITypeEditorEditStyle Implements C1.Win.C1FlexGrid.IC1EmbeddedEditor.C1EditorGetStyle
        Return System.Drawing.Design.UITypeEditorEditStyle.None
    End Function

    Public Function C1EditorGetValue() As Object Implements C1.Win.C1FlexGrid.IC1EmbeddedEditor.C1EditorGetValue
        Return DirectCast(Me.SelectedItem, CustomItem).Key
    End Function

    Public Sub C1EditorInitialize(ByVal value As Object, ByVal editorAttributes As System.Collections.IDictionary) Implements C1.Win.C1FlexGrid.IC1EmbeddedEditor.C1EditorInitialize
        For Each item As CustomItem In Me.Items
            If item.Key = value Then
                Me.SelectedItem = item
                Exit Sub
            End If
        Next
    End Sub

    Public Function C1EditorKeyDownFinishEdit(ByVal e As System.Windows.Forms.KeyEventArgs) As Boolean Implements C1.Win.C1FlexGrid.IC1EmbeddedEditor.C1EditorKeyDownFinishEdit
        Return False
    End Function

    Public Sub C1EditorUpdateBounds(ByVal rc As System.Drawing.Rectangle) Implements C1.Win.C1FlexGrid.IC1EmbeddedEditor.C1EditorUpdateBounds
        MyBase.Location = rc.Location
        MyBase.Size = rc.Size
    End Sub

    Public Function C1EditorValueIsValid() As Boolean Implements C1.Win.C1FlexGrid.IC1EmbeddedEditor.C1EditorValueIsValid
        Return True
    End Function
End Class

''' <summary>
''' Data For Dropdown
''' </summary>
Public Class CustomItem
    Public Property Key As Integer
    Public Property Value As String
    Public Sub New(key As Integer, value As String)
        Me._Key = key
        Me._Value = value
    End Sub
    Public Overrides Function ToString() As String
        Return Me.Value
    End Function
End Class

''' <summary>
''' Data For the grid
''' </summary>
Public Class Persons
    Public Property Name As String
    Public Property ID As Integer
    Public Property Present As Boolean
End Class
